## simulate multidimensional IRT Ordinal Randomized Response Data 




simdata <- function(N,K,C,Q,P){
  library(MASS)
 #+ .2*(1-diag(2))
# 
if(P>1){
X <- cbind(1,matrix(rnorm(N*(P-1),sd=1),ncol=(P-1)))
   ## garandeert dat E(theta) =0
for(pp in 2:P){X[,pp] <- X[,pp] - mean(X[,pp])
               X[,pp] <- X[,pp]/sd(X[,pp])
}

B <- matrix(c(0,1,0,0,0,1),nrow=P,ncol=Q)
#B[1,] <- 0
#B <- t(B)
mutheta <- X %*% (B)

#for(ii in 1:Q){
#  B[,ii] <- B[,ii]/sd(mutheta[,ii])
#  mutheta[,ii] <- mutheta[,ii]/sd(mutheta[,ii])
#}
#var(mutheta)
SigmaP <- diag(Q)*1
SigmaP[1,2] <- SigmaP[2,1] <- .3
} 
if(P==1) {
  mutheta <- rep(0,Q)
  SigmaP <- diag(Q)
}
theta <- mutheta + mvrnorm(N,mu=rep(0,Q),Sigma=SigmaP,empirical=TRUE)

#a1 <- rlnorm(K,meanlog=0,sdlog=.2)
#a2 <- rlnorm(K,meanlog=-.75,sdlog=.2)

draw <- rnorm(5*K*Q,mean=0,sd=sqrt(.3))
draw <- draw[which(abs(draw)>.25)]
draw <-   draw[1:(K*Q)]
A <- matrix(draw,ncol=Q,nrow=K)
  A[1:2,1:Q] <- 0

   	for(qq in 1:Q){
   		A[qq,qq] <- 1
   	}
tau <- t(matrix(seq(1:(C-1)) - mean(seq(1:(C-1))),ncol= K,nrow=C-1))

Qdum <- array(0,dim=c(N,K,C))
p <-  array(0,dim=c(N,K,C))
Y <- matrix(0,ncol=K,nrow=N)

for (i in 1 : N) {
	for (k in 1 : K) {	
		for (c in 1 : (C-1)) {
		 	#Q[i, k, c] <- pnorm(tau[k,c] - (a1[k]*theta[i,1] + a2[k] * theta[i,2]))
		 	Qdum[i, k, c] <- pnorm(tau[k,c] - (A[k,]%*%as.matrix(theta[i,],ncol=1)))
		}
	
			p[i,k,1] <- 0.666 * Qdum[i,k,1] +  0.334*0.25
			p[i,k,2] <- 0.666 * (Qdum[i,k,2] -Qdum[i,k,1] ) +  0.334*0.25
			p[i,k,3] <- 0.666 * (Qdum[i,k,3] -Qdum[i,k,2])  +  0.334*0.25
			p[i,k,4] <- 0.666 * (1-Qdum[i,k,3])  +  0.334*0.25
}}
	
for (i in 1:N) {
	for(k in 1:K){
		Y[i,k] <- sample(1:C, 1, prob = p[i,k,])
	}
}

return(list(A=A,Y=Y,theta=theta,tau=tau, SigmaP=SigmaP,B = B,X=X))
}


